import { JetBase } from "./JetBase";
import { IBaseView, IJetApp, IJetConfig, IJetRouter, IJetURL, IJetURLChunk, IJetView, IRoute, ISubView, IViewConfig } from "./interfaces";
export declare class JetAppBase extends JetBase implements IJetView {
    config: IJetConfig;
    app: IJetApp;
    ready: Promise<any>;
    callEvent: (name: string, parameters: any[]) => boolean;
    attachEvent: (name: string, handler: any) => void;
    private $router;
    private _services;
    private _subSegment;
    constructor(config?: any);
    getUrl(): IJetURL;
    getUrlString(): string;
    getService(name: string): any;
    setService(name: string, handler: any): void;
    destructor(): void;
    copyConfig(obj: any, target: any, config: IViewConfig): any;
    getRouter(): IJetRouter;
    clickHandler(e: Event): void;
    getRoot(): IBaseView;
    refresh(): Promise<any>;
    loadView(url: string): Promise<IJetView>;
    _forView(target: HTMLElement, handler: any): void;
    _loadViewDynamic(url: any): any;
    createFromURL(chunk: IJetURLChunk, now?: IJetView): Promise<IJetView>;
    createView(ui: any, name?: string): any;
    show(url: string): Promise<any>;
    trigger(name: string, ...rest: any[]): void;
    apply(name: string, data: any[]): void;
    action(name: string): any;
    on(name: string, handler: any): void;
    use(plugin: any, config: any): void;
    error(name: string, er: any[]): void;
    render(root?: string | HTMLElement | ISubView, url?: IRoute | string, parent?: IJetView): Promise<IBaseView>;
    getSubView(): IJetView;
    private _first_start;
    private _loadError;
    private addSubView;
}
